#!/usr/bin/perl

####################################################
#File: eAsp-shell.pl
#Electronic Assisstant - Single-thread Perl-based
#Author: eAsp written by Mike Tremaine [mgt@stellarcore.net]
#Copyright: Mike Tremaine 03/28/2012
#Version:
# $Id: 
#####################################################
#Todo: Should this be turned into a socket server?
# 
#
#LIBS
use Term::ReadLine;

#Globals
$config::user   = "$ENV{'USER'}";
$config::datadir = "$ENV{'HOME'}/.eAsp";

use lib "$ENV{'HOME'}/bin/eAsp";
eval { 
    require "eAsp_functions.pl";
 } or do {
    print "Unable to Load eAsp_functions.pl\n";
    print "Please install in $ENV{'HOME'}/bin/eAsp \n";
    exit;
 };

##################################################################
#Main Program

#Seed Random
#Perl 5.004 and above seed random for you but....
srand (time ^ $$ ^ unpack "%L*", `ps -axww | gzip -f`);

#Check datadir
if (!-d "$config::datadir") { mkdir($config::datadir); };

my $terminal = new Term::ReadLine 'eAsp';
my $prompt = "eAsp:";
my $out = $terminal->OUT || \*STDOUT;

#Call Input Loop
while () {
   get_input();
}

#Anything to Clean up?

exit 0;

##################################################################
# input loop
sub get_input {
   #print "eAsp: ";
   #my $line = <STDIN>;
   my $line = $terminal->readline($prompt);
   $terminal->addhistory($line);
   chomp $line;
   #Parse line roll cast set       
   &on_msg(lc ($line));
}


###################################################################
#
# On_msg reacts to msg
sub on_msg{

   my ($msg) = @_;

   my $ts = scalar(localtime);
   my $character = $config::user;
 
   if ( $msg =~ s/^(\w+),\s*//i ) {
      $character = $1;
   } 
      
   if ( $msg =~ /^(\w+)/i ) {
        my $command = $1;
        my $found = 0;
        for my $functions (@global::functions) {
         #Need to lowercase command
            if ( $functions eq $command ) {
                my $call = "function_" . $command;
                eval { &{$call}($character,$msg); };
                $found = 1;
                last;
            }
    }

      if ($found == 0 ) {
	      print "$command is unknown please add it to the global::functions list \n"; 
      }
   }

}

###############################
#Random Number Generator
#Feed it a limit #
sub random_number {

   my $limit = shift (@_);

   #Note srand was set in globals
   #Random Generator
   my $number = int(rand($limit) + 1);

   return($number);

}

#######################################################################
#Reload
sub function_reload {

   #All other function_foo belong in eAsp.functions
   delete $INC{"eAsp_functions.pl"};
   require "eAsp_functions.pl";

}

#vi: shiftwidth=4 tabstop=4 et
