#!/usr/bin/perl

######################################################################
#File: eAsp_functions.pl
#Author: Mike Tremaine [mgt@stellarcore.net]
#Copyright 02/06/2004 
#Modular Functions for the eAsp shell.
#Version:
# $Id:
######################################################################
#To reload the file live type reload 
#Todo: function_hit function_heal for HP tracking?
#
#
####################################################################
#Add the command name to this list when you add a new function. 
#This provides some protections against the "no strict refs" we had to use 
#In the eAsp.pl file, as only defined functions can be called. -mgt
####################################################################
@global::functions = ("alias", "attack", "help","init", "load", "math", "quit", "reload","roll","save",
	"set","show","showall","showinit","skill","unset","write");


########################################################################
#Attack
# alias <new_default_username>
sub function_alias {
    my ($character, $msg) = @_;
    if ($msg =~ /^alias\s*([\w\-]+)\s?$/oi ) { 
        $config::user = $1;
    }    
}

########################################################################
#Attack
# attack and attack <alias> where <alias> has value #,#
sub function_attack {

my ($character, $msg) = @_;
if ($msg =~ /^attack\s*([\w\-]+)?\s?$/oi ) { 
    #it would be clever to match saved character names first and pull them and pass the rest
    my $attack_type = $1; 
    if ($global::data{$character}{$attack_type}) {

        #alias format +ToHit,+dice+Damage -mgt
        my ($tohits,$damages) = split(/,/,$global::data{$character}{$attack_type});
        my @rolls = split(/ /,$tohits);

        for my $tohit (@rolls) {
            my $roll=&random_number(20);             #roll a 20-sided die
            my $total = $roll + $tohit;
            print "$attack_type attack roll is $total [$roll + $tohit]\n";
        }

        my @drolls = split(/\:/, $damages);
        for my $damage (@drolls) {
	    	#Damage section
            #Check for aliases
            #This is alias expansion - strange must have been something saf wanted -mgt
            my @alias_check = split(/ /, $damage);
            for my $alias (@alias_check) {
                if ($global::data{$character}{$alias}) {
                    $damage =~ s/$alias/$global::data{$character}{$alias}/;
                }
            }

            if ( $damage =~ /^[d|\d|\+|\/|\-|\*|\%\(\)\.\s]+$/goi ) {
                my $in_roll = "$damage";
                my ($total, $i, $dice, $dicerolled);
                while ($damage =~ m/([0-9]*)?d([0-9]+)/ ) {
                    $total = 0;
                    if (!$1) { $dice = 1; } else { $dice = $1; };
                    my $limit = $2;
                    for ($i=0; $i<$dice;$i++){             #loop for dice
                        my $roll=&random_number($limit);
                        $dicerolled .= "$roll ";
                        $total = $roll + $total;    #running total
                    }
                    $damage =~ s/([0-9]*)?d([0-9]+)/$total/;
                } #End while #d#
                #Using eval for math -mgt
                if ($damage) { $total = eval "$damage"; }
                chop $dicerolled;
                print "$character\'s Damage roll is $total [$dicerolled on $in_roll]\n";
	        }
        }
    } else {
        my $roll=&random_number(20);             #roll a 20-sided die
        print "$character\'s unmodified attack roll is $roll\n";
    }
 }

}

########################################################################
#Help
# !help !help <foo> where foo is listed commands.
# Beware of ordering for regex, example if help show was before help showall, then showall fails.
# This is due to lazy regex's but it should be fine -mgt
sub function_help {

my ($character, $msg) = @_;
if ( $msg =~ /^help attack/i ) {
    print "Attack: attack rolls a d20 for you.\n";
    print "<Namespace-Alias>, attack <Alias> rolls a d20 + Modifiers listed for the user with the alias. It will also roll damage if set\n";
    print "To create a weapon or creature alias do <foo>, set longsword <#Bonustohit>,<#damagedice +/- bonus>\n";
    print "The <foo> is optional of course it is considered the Namespace of your alias. Consider this example set trolls 6 6 6,1d4:1d4:1d8\n";
    print "attack trolls -- This will roll all three attacks at +6 and damage for each attack\n";
} elsif ( $msg =~ /^help alias/i ) {
    print "alias set the default namespace. When the eAsp first starts the system username is the default.\n";
} elsif ( $msg =~ /^help init/i ) {
    print "Init: init rolls a d6 for you.\n";
    print "If you set your init alias with your bonus it will add it.\n";
    print "Do set <Foo>, init <#BonustoInit>\n";
    print "You can also use init set <word> <number>\n";
    print "To set init values manually\n";
    print "and init delete <word>\n";
    print "To delete init values manually\n";
} elsif ($msg =~ /^help load/i) {
    print "Load: load tells eAsp to load your saved data from file, use <User>, load to get datafiles other then the default\n";
    print "You must have used write at some point to use load. See also help write\n";
} elsif ( $msg =~ /^help math/i ) {
    print "math and any combo of # + - / * () % \n";
    print "example: math 160 + (5 * 25)\n";
} elsif ( $msg =~ /^help roll/i ) {
    print "Die Rolling:\n";
    print "             roll #d# or roll d#\n";
    print "             roll #d# [-+*/] # \n";
} elsif ( $msg =~ /^help reload/i ) {
    print "Reload: reload allows you to reload the eAsp_functions.pl file\n";
    print "Do not use this unless you made changes to the eAsp_functions.pl file\n";
    print "and have run a perl -d eAsp_functions.pl to make sure it is ok first!!.\n";
} elsif ($msg =~ /^help save/i) {
    print "Save: save <Type> tells eAsp to roll a saving throw for you\n" ;
    print "Based on your defined bonuses. To set your saves use set saves #,#,#,#,#,# in the order \n" ;
} elsif ( $msg =~ /^help quit/i ) {
    print "Will quit the eAsp shell, you will lose all variables unless saved with a write\n";
} elsif ( $msg =~ /^help set/i ) {
    print "Set: set <foo> <bar> allows you to set variables for you <character>\n" ;
    print "Each character has its own namespace and values are limited to 256 characters.\n" ;
    print "See also help print !help unset help show help showall\n" ;
} elsif ( $msg =~ /^help showall/i ) {
    print "Showall: showall allows you to see all the values of all the variables set by set\n" ;
    print "See also help set\n" ;
} elsif ( $msg =~ /^help show/i ) {
    print "Show: show <foo> allows you to see the value of a variable set by set\n" ;
    print "See also help print !help set help unset \n" ;
} elsif ($msg =~ /^help skill/i) {
    print "Skill: skill <Type> tells eAsp to roll a skill roll for you\n" ;
    print "Based on your defined bonuses. To set your skills use !set <skill> #\n" ;
    print "Example set hide 5\n" ;
} elsif ( $msg =~ /^help unset/i ) {
    print "Unset: unset <foo> allows you to delete the value of a variable set by !set\n" ;
    print "See also help show !help unset\n " ;
} elsif ($msg =~ /^help write/i) {
    print "Write: write tells eAsp to save your data to file\n" ;
    print "If you should ever need to restore your data use load. See also help load\n" ;
} else {
    print "Things you can ask me:\n";
    print "help alias\t help attack\nhelp init\t help load\nhelp math\t help quit\nhelp reload\t help roll\n";
    print "help set\t help skill\nhelp show\t help showall\nhelp unset\t help write\n";
 }

}

########################################################################
#Init
# !init will user character->init if exists and value is #.
# !init reset clear values os _init-$channel hash
sub function_init {

my ($character, $msg) = @_;
#Removed the concept of channels from eAsp Shell
my $channel_lock = "_init";

if ($msg =~ /^init\s*(\w+)?/o ) { 
    my $option = $1;
    if ($option eq "reset") {
        #clear init values
        for my $key (keys %{ $global::data{$channel_lock}}) {
            delete $global::data{$channel_lock}{$key};
        }
    } elsif ($option eq "set") {
        my ($init_var, $init_num) = $msg =~ m/^\init\s*\w+\s+(\w+)\s+(\d+)/o;
        if ( ($init_var =~ /\w+/) && ($init_num =~ m/\d+/)) {
            #set new init value
            if (($character eq "DM") || ($character eq "GM")) {
                #Nothing let it pass
            } else {
                $init_var = "$character" . "_" . "$init_var"; 
            }
            $global::data{$channel_lock}{$init_var} = $init_num;
        } else {
            #Error post back
            print "I do not understand $msg \n" ;
        } 
    } elsif ($option eq "delete") {
        my ($init_var) = $msg =~ m/^\init\s*\w+\s+(\w+)/o;
        if ($init_var =~ /\w+/) {
            #delete init value
            if (($character eq "DM") || ($character eq "GM")) {
                delete $global::data{$channel_lock}{$init_var};
            } else {
                $init_var = "$character" . "_" . "$init_var"; 
                delete $global::data{$channel_lock}{$init_var};
            }
        } else {
            #Error post back
            print "I do not understand $msg \n" ;
        }
    } else {
        #roll init save value
        if ($global::data{$character}{init}) {
            my $bonus = $global::data{$character}{init};
            #alias format +ToInit -mgt
            my $roll=&random_number(6);             #roll a 6-sided die
            my $total = $roll + $bonus;
            $global::data{$channel_lock}{$character} = $total;
            print "$character\'s Initiative roll is $total [$roll + $bonus] \n" ;
        } else {
            my $roll=&random_number(6);             #roll a 20-sided die
		    $global::data{$channel_lock}{$character} = $roll;
            print "$character\'s unmodifed  initiative roll is $roll \n" ;
        }
    } #End options or roll
 } #End if init

}

#######################################################################
#Load
# !load loads <character>.dat from disk. Allows us to preserve data across reboots -mgt
sub function_load {

my ( $character, $msg ) = @_;
if ($msg =~ /^load/o ) {
    open(DATA,"<$config::datadir/$character.dat");
    my @data = <DATA>;
    close DATA;
        
    for my $line (@data) {
        chomp $line;
        my ($key,$value) = split(/\|\|/, $line);
        $global::data{$character}{$key} = "$value";
    }
    print "$character Your data has been restored\n" ;
 } else {
    print "I do not understand $msg\n" ;
 }
}

########################################################################
#MATH
sub function_math {

my ( $character, $msg ) = @_;

#Strip math to get to the numbers
$msg =~ s/^math\s*//;

#Should I add ^
if ( $msg =~ /^[\d|\+|\/|\-|\*|\%\(\)\.\s]+$/gi ) {
    #Using eval for math -mgt
    if ($msg) { $total = eval "$msg"; }
    print "$msg =  $total\n" ;
 }

}

########################################################################
#Quit
sub function_quit {
    print "Good-bye \n";
    exit;
}

########################################################################
#Roll
# !roll #d# +-*/ # The dieroller -mgt
sub function_roll {

my ( $character, $msg ) = @_;

#Strip roll to get to the numbers
$msg =~ s/^roll\s*//;

#Check for aliases
my @alias_check = split(/ /, $msg);
for my $alias (@alias_check) {
    if ($global::data{$character}{$alias}) {
        $msg =~ s/$alias/$global::data{$character}{$alias}/;
    }
}

if ( $msg =~ /^[d|\d|\+|\/|\-|\*|\%\(\)\.\s]+$/gi ) {
    my $in_roll = "$msg";
    chomp $in_roll;
    my ($total, $i, $dice, $dicerolled);
    while ($msg =~ m/([0-9]*)?d([0-9]+)/ ) {
        $total = 0;
        if (!$1) { $dice = 1; } else { $dice = $1; };
        my $limit = $2;
        for ($i=0; $i<$dice;$i++){             #loop for dice
            my $roll=&random_number($limit);             
            $dicerolled .= "$roll ";
            $total = $roll + $total;    #running total
        }
        $msg =~ s/([0-9]*)?d([0-9]+)/$total/;
    } #End while #d#
    #Using eval for math -mgt
    if ($msg) { $total = eval "$msg"; }
    chop $dicerolled;
    print "$character\'s roll comes to $total [$dicerolled on $in_roll]\n" ;
 } else {
    print "$character I do not understand $msg\n" ;
 }
}

########################################################################
#Saving Throws
# save <type> will user character->saves  if exists and value is #.
sub function_save {

#Fixme S,I,W,C,D,Ch
my ($character, $msg) = @_;
if ($msg =~ /^save\s+(\w+)/o ) { 
    if ($global::data{$character}{saves}) {
        my @Bonus = split(/,/, $global::data{$character}{saves});
	 	my $type = $1;
		my $bonus;
	 	if ($type =~ /^s/i ) { $type = "Strength"; $bonus = $Bonus[0]; };
	 	if ($type =~ /^i/i ) { $type = "Intelligence"; $bonus = $Bonus[1]; };
	 	if ($type =~ /^w/i ) { $type = "Wisdom"; $bonus = $Bonus[2]; };
	 	if ($type =~ /^ch/i ) { $type = "Charisma"; $bonus = $Bonus[5]; };
	 	if ($type =~ /^c/i ) { $type = "Constitution"; $bonus = $Bonus[3]; };
	 	if ($type =~ /^d/i ) { $type = "Dexterity"; $bonus = $Bonus[4]; };
        #alias format +ToInit -mgt
        my $roll=&random_number(20);             #roll a 20-sided die
        my $total = $roll + $bonus;
        print "$character\'s $type saving throw is $total [$roll + $bonus] \n" ;
    } else {
        my $roll=&random_number(20);             #roll a 20-sided die
        print "$character\'s unmodifed saving throw is $roll \n" ;
    }
 }
}

#######################################################################
#Save aka Write
# !save saves to disk the $global::data->{Nick} namespace to <character>.dat -mgt
sub function_write {

my ($character, $msg ) = @_;
if ($msg =~ /^write/o ) {
    open(DATA,">$config::datadir/$character.dat");
    for $key (keys %{ $global::data{$character}}) {
        my $value = "$global::data{$character}{$key}";
        print DATA "$key||$value\n";
    }
    close DATA;
    print "$character Your data has been saved \n" ;
} else {
    print "I do not understand $msg \n" ;
 }
}
#######################################################################
#Set
# !set <foo> <bar> allows us to use variables -mgt
# Hard limit of 256 characters for value, and no spaces in variable name! -mgt
sub function_set {

my ($character, $msg ) = @_;
if ($msg =~ /^set\s([\w-]+)\s(.{1,256})/o ) {
    my $variable = $1;
    my $value = $2;
    $global::data{$character}{$variable} = "$value";
    print "$character $variable set \n" ;
} else {
    print "$character I do not understand $msg \n" ;
 }
}

#######################################################################
#Show
# show <foo> echos value of <foo> -mgt
sub function_show {

my ($character, $msg ) = @_;
if ($msg =~ /^show\s([\w\-]+\s?$)/o ) {
    my $variable = $1;
    my $value = "$global::data{$character}{$variable}";
    print "$variable is $value \n" ;
} else {
    print "I do not understand $msg \n" ;
 }
}

#######################################################################
#Showall
# !showall echos all the set variables as private message 
# Watch for excess flood! -mgt
sub function_showall {

my ($character, $msg ) = @_;
if ($msg =~ /^showall/o ) {
    print "*****Showing ALL for $character:\n" ;
    my $output;
    my $counter = 0;
    for $key (sort keys %{ $global::data{$character}}) {
        my $value = "$global::data{$character}{$key}";
            $output = $output . "$key = $value\n";
    }
	print "$output" ;
} else {
    print "I do not understand $msg\n" ;
 }
}

#######################################################################
#Showinit
# !showinit echos all the collected inits 
sub function_showinit {

my ( $character, $msg ) = @_;
if ($msg =~ /^showinit/o ) {
    print "*****init order \n" ;
    #Build channel name
    my $channel_lock = "_init";
    for $key (sort { $global::data{$channel_lock}{$b} <=> $global::data{$channel_lock}{$a} }
	    keys %{ $global::data{$channel_lock}}) {
        my $value = "$global::data{$channel_lock}{$key}";
        print "$key = $value\n" ;
    }
} else {
    print "I do not understand $msg\n" ;
 }
}
########################################################################
#Skill
# !skill and !skill <alias> where <alias> has value #
sub function_skill {

my ($character, $msg) = @_;
if ($msg =~ /^skill\s*([\w\-]+)?\s?$/oi ) { 
    my $skill_type = $1; 
    if ($global::data{$character}{$skill_type}) { 
        my $bonus = $global::data{$character}{$skill_type};
        my $roll=&random_number(20);             #roll a 20-sided die
        my $total = $roll + $bonus;
        print "$character\'s $skill_type check is $total [$roll + $bonus] \n" ;
    } else {
        my $roll=&random_number(20);             #roll a 20-sided die
        print "$character\'s unmodified skill check is $roll \n" ;
    }
 }
}

#######################################################################
#UnSet
# !unset <foo> deletes value of <foo> as set by !set -mgt
sub function_unset {

my ( $character, $msg ) = @_;

if ($msg =~ /^unset\s([\w\-]+)\s?$/o ) {
    my $variable = $1;
    delete $global::data{$character}{$variable};
    print "$character $variable unset\n" ;
} else {
    print "$character I do not understand $msg\n" ;
 }
}

1;

# vi: shiftwidth=4 tabstop=4 et
